unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type


  { TTestThread }

  TTestThread = class(TThread)
    private
      procedure SendeCaption;
    protected
      procedure Execute; override;
    public
      Constructor Create(CreateSuspended : boolean);
    end;

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  TestThread: TTestThread;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
//  TestThread.Execute;
  TestThread.Resume;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  TestThread:=TTestThread.Create(True);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if not TestThread.Finished then begin
    TestThread.Terminate;
    TestThread.WaitFor;
  end;
end;

{ TTestThread }

procedure TTestThread.SendeCaption;
begin
  Form1.Caption:='Test ' + inttostr(random(100));
end;

procedure TTestThread.Execute;
begin
  Synchronize(@SendeCaption);
end;

constructor TTestThread.Create(CreateSuspended: boolean);
begin
  FreeOnTerminate := True;
  inherited Create(CreateSuspended);
end;

end.

